<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>edge</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="corr2.html">&lt;&lt; corr2</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f17847494401c51daa9e1bfe09408f94.html">Image Analysis and Statistics</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="imhist.html">imhist &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">IPCV - Image Processing and Computer Vision Toolbox for Scilab</a> &gt;&gt; <a href="section_f17847494401c51daa9e1bfe09408f94.html">Image Analysis and Statistics</a> &gt; edge</span>

    <br /><br />
    <div class="refnamediv"><h1 class="refname">edge</h1>
    <p class="refpurpose">Find edges in a single channel image.</p></div>


<div class="refsynopsisdiv"><h3 class="title">Syntax</h3>
   <div class="synopsis"><pre><span class="default">E</span><span class="default"> = </span><span class="functionid">edge</span><span class="default">(</span><span class="default">im</span><span class="default">, </span><span class="default">method</span><span class="default">)</span>
<span class="default">E</span><span class="default"> = </span><span class="functionid">edge</span><span class="default">(</span><span class="default">im</span><span class="default">, </span><span class="default">method</span><span class="default">, </span><span class="default">thresh</span><span class="default">)</span>
<span class="default">E</span><span class="default"> = </span><span class="functionid">edge</span><span class="default">(</span><span class="default">im</span><span class="default">, </span><span class="default">method</span><span class="default">, </span><span class="default">thresh</span><span class="default">, </span><span class="default">direction</span><span class="default">)</span>
<span class="default">E</span><span class="default"> = </span><span class="functionid">edge</span><span class="default">(</span><span class="default">im</span><span class="default">, </span><span class="default">method</span><span class="default">, </span><span class="default">thresh</span><span class="default">, </span><span class="default">sigma</span><span class="default">)</span>
<span class="default">[</span><span class="default">E</span><span class="default">, </span><span class="default">thresh</span><span class="default">] = </span><span class="functionid">edge</span><span class="default">(</span><span class="default">im</span><span class="default">, </span><span class="default">method</span><span class="default">, ...)</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">im :</span>
      <dd><p class="para">Input image which must be a single channel image.</p></dd></dt>
   <dt><span class="term">method :</span>
      <dd><p class="para">may be &#0039;sobel&#0039;(default), &#0039;prewitt&#0039;, &#0039;log&#0039;, &#0039;fftderiv&#0039; or &#0039;canny&#0039;. Other methods will appear in the future.</p></dd></dt>
   <dt><span class="term">thresh :</span>
      <dd><p class="para">sets the threshold level, from 0 to 1. Defaults to 0.2. If negative, then the output image, E , will have the un-thresholded gradient image.</p></dd></dt>
   <dt><span class="term">direction :</span>
      <dd><p class="para">may be &#0039;horizontal&#0039;, &#0039;vertical&#0039; or &#0039;both&#0039;(default). This determines the direction to compute the image gradient.</p></dd></dt>
   <dt><span class="term">sigma :</span>
      <dd><p class="para">Controls the ammount of high-frequency attenuation in some methods (only the &#0039;fftderiv&#0039; method uses this parameter). This can be used to obtain different levels of detail and to filter out high-frequency noise.</p></dd></dt>
   <dt><span class="term">E :</span>
      <dd><p class="para">edge image which is boolean matrix and has the same size as im . If thresh&lt;0 , E is a double un-thresholded image.</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">The function edge performs edge detection on a grayscale intensity image. The user may set the method, the threshold level, the direction of the edge detection, etc.</p>
   <p class="para">E=edge(im, &#0039;sobel&#0039;, thresh, direction)
Detects edges in im , using the sobel gradient estimator.</p>
   <p class="para">E=edge(im, &#0039;prewitt&#0039;, thresh, direction)
Detects edges in im , using the prewitt gradient estimator.</p>
   <p class="para">E=edge(im, &#0039;log&#0039;, thresh, sigma)
Detects edges in im , using the the Laplacian of Gaussian method. sigma is the standard deviation of the LoG filter and the size of the LoG filter is nxn, where n = ceil(sigma*3)*2+1. The default value for sigma is 2.</p>
   <p class="para">E=edge(im, &#0039;fftderiv&#0039;, thresh, direction, sigma)
Detects edges in im , using the FFT gradient method, default sigma 1.0</p>
   <p class="para">E=edge(im, &#0039;canny&#0039;, thresh, sigma)
Detects edges in im , using Canny method. thresh is a two-element vector, in which the fist element is the low threshold and the seond one is the high threshold. If thresh is a scalar, the low threshold is 0.4*thresh and the high one is thresh . Besides, thresh can not be negative scalar. sigma is the Aperture parameter for canny operator, which must be 1, 3, 5 or 7. default thresh 0.2; default sigma 3.</p>
   <p class="para">Supported classes: INT8, UINT8, INT16, UINT16, INT32, DOUBLE.</p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabid">im</span> <span class="scilaboperator">=</span> <span class="scilabid">imread</span><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://fullpath">fullpath</a><span class="scilabopenclose">(</span><span class="scilabid">getIPCVpath</span><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span> <span class="scilaboperator">+</span> <span class="scilabstring">&#0034;</span><span class="scilabstring">/images/baboon.png</span><span class="scilabstring">&#0034;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">im</span> <span class="scilaboperator">=</span> <span class="scilabid">rgb2gray</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">E</span> <span class="scilaboperator">=</span> <span class="scilabid">edge</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">sobel</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">E</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">E</span> <span class="scilaboperator">=</span> <span class="scilabid">edge</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">canny</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span> <span class="scilabopenclose">[</span><span class="scilabnumber">0.06</span><span class="scilabdefault">,</span> <span class="scilabnumber">0.2</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">E</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">E</span> <span class="scilaboperator">=</span> <span class="scilabid">edge</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">prewitt</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">mat2gray</span><span class="scilabopenclose">(</span><span class="scilabid">E</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="fspecial.html" class="link">fspecial</a></li>
   <li class="member"><a href="imfilter.html" class="link">imfilter</a></li>
   <li class="member"><a href="filter2.html" class="link">filter2</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">Shiqi Yu (SIVP)</li>
   <li class="member">Ricardo Fabbri (SIP)</li>
   <li class="member">Tan Chin Luh (IPCV)</li></ul></div>
    <br />

    <div class="manualnavbar">
    <table width="100%">
    <tr><td colspan="3" class="next"><a href="http://bugzilla.scilab.org/enter_bug.cgi?product=Scilab%20software&component=Documentation%20pages" class="ulink">Report an issue</a></td></tr>
<tr>
      <td width="30%">
    	<span class="previous"><a href="corr2.html">&lt;&lt; corr2</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f17847494401c51daa9e1bfe09408f94.html">Image Analysis and Statistics</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="imhist.html">imhist &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
